def cellule(tete, queue):
    """
    Construit une liste chaînée en rajoutant l'élément tête au
    *début* de la liste chaînée queue. La liste queue n'est pas
    modifiée par cette opération.

    Renvoie une cellule variable.
    """

    return [tete, queue]


def concatener(l1, l2):
    """
    Renvoie une nouvelle liste chaînée qui sera la concaténation
    de l1 et de l2.

    Les listes l1 et l2 ne sont pas modifiées par cette appel.
    """

    if est_vide(l1):
        return l2
    else:
        return cellule(tete(l1), concatener(queue(l1), l2))
        

def tete(liste):
    """
    Renvoie le premier élément de la liste chaînée passée en
    paramètre.
    """

    return liste[0]


def queue(liste):
    """
    Renvoie la liste chaînée liste privée de son premier élément
    (la liste passée en paramètre n'est cependant pas modifiée
    par cette opération).

    Déclenche une erreur si appelé sur une liste vide.
    """

    return liste[1]


def liste_vide():
    """
    Renvoie une liste chaînée vide.
    """

    return None


def est_vide(liste):
    """
    Teste si une liste chaînée est vide ou non.
    """

    return liste is None
